<template>
    <div class="control-userBigTop animated fadeInUp">
        <p class="text-bold">{{ $t('users.form.title') }} {{ user.login }} [  {{ user.last_login_ip }} ]</p>

        <form action="" @submit.prevent="submit">
            <div class="box__input__bigPage">
                <label for="form_password">{{ $t('users.form.password') }}</label>
                <div class="box-input__info">
                    <input type="password" id="form_password" v-model="form.password">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage">
                <label for="form_password_confirmation">{{ $t('users.form.password_repeat') }}</label>
                <div class="box-input__info">
                    <input type="password" id="form_password_confirmation" v-model="form.password_confirmation">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage">
                <label for="form_email"><span>*</span> {{ $t('users.form.email') }}</label>
                <div class="box-input__info">
                    <input type="email" id="form_email" v-model="form.email">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage">
                <label for="form_balance">{{ $t('users.form.balance') }}</label>
                <div class="box-input__info">
                    <input type="text" id="form_balance" v-model.number="form.balance" :readonly="balances_type === 'divided'">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage">
                <label for="form_currency_id">{{ $t('users.form.currency') }}</label>
                <div class="box-input__info">
					<form-select id="form_currency_id" v-model="form.currency_id" name="currency_id" :options="currencies"
								 :wrapper-style="{width: '391px'}" :span-style="{color: '#383838',padding: '14px 0 14px 15px', width: 'calc(100% - 17px)'}" :custom-options-style="{'z-index': 1}"/>
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage" v-for="(wallet, key) in wallets" v-if="balances_type === 'shared'">
                <label :for="`wallet_${key}`">{{ $t('users.form.wallet', {code: wallet}) }}</label>
                <div class="box-input__info">
                    <input type="text" :id="`wallet_${key}`" v-model="form.wallets[key]">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage">
                <label for="form_referral_percent">{{ $t('users.form.referral_percent') }}</label>
                <div class="box-input__info">
                    <input type="text" id="form_referral_percent" v-model="form.referral_percent">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <div class="box__input__bigPage">
                <label for="form_comment">{{ $t('users.form.comment') }}</label>
                <div class="box-input__info">
                    <input type="text" id="form_comment" v-model="form.comment">
                    <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                </div>
            </div>
            <button class="save_NoBg">{{ $t('users.form.submit') }}</button>
        </form>
    </div>
</template>

<script>
    import {mapGetters} from "vuex";
    import Currencies from "../../currencies";
    import laravelValidationErrorParse from "../../mixins/laravelValidationErrorParse";
    import _ from "lodash";

    export default {
		name: "UserForm",
        mixins: [laravelValidationErrorParse],
        props: ['user'],
        data(){
		    return {
		        form: {
		            id: this.user.id,
		            password: '',
                    password_confirmation: '',
                    email: this.user.email,
                    balance: this.user.balance,
                    currency_id: this.user.currency_id,
                    referral_percent: this.user.referral_percent,
                    comment: this.user.comment,
                    wallets: {}
                },
                payment_systems: undefined
            }
        },
        watch: {
		    user(newUser){
		        this.form.id = newUser.id;
                this.form.password = '';
                this.form.password_confirmation = '';
                this.form.email = newUser.email;
		        this.form.balance = newUser.balance;
                this.form.currency_id = newUser.currency_id;
                this.form.referral_percent = newUser.referral_percent;
                this.form.comment = newUser.comment;
                if(this.balances_type === 'shared'){
                    this.loadWallets();
                }
            }
        },
        computed: {
            ...mapGetters([
                'axios',
                'balances_type',
            ]),
            currencies(){
                let currencies = Currencies.currencies;
                let options = {};
                if(Array.isArray(currencies) && currencies.length){
                    _.map(currencies, currency => {
                        options[currency.id] = currency.name;
                    });
                }
                return options;
            },
            wallets(){
                let wallets = {};
                _.each(this.payment_systems, (ps) => {
                    wallets[ps.id] = ps.code;
                });
                return wallets;
            }
        },
        methods: {
		    loadWallets(){
                this.axios
                    .get(`users/${this.user.id}/payment_systems`)
                    .then(resp => resp.data)
                    .then(payment_systems => this.payment_systems = payment_systems)
                    .then(() => this.fillWallets());
            },
            fillWallets(){
                _.each(this.payment_systems, (ps) => {
                    let key = ps.id;
                    this.form.wallets[key] = _.get(ps, ['wallets', '0', 'wallet']);
                });
            },
            submit(){
                this.axios
                    .post(`users/${this.user.id}`, this.form)
                    .then(resp => resp.data)
                    .then(data => {
                        if('success' === data.status){
                            this.$swal(this.$t('ui.success'));
                            this.$emit('reload-user')
                        }else{
                            this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    })
                    .catch((error) => {
                        this.displayErrorsSwal(error);
                    });
            }
        },
        mounted() {
            if(this.balances_type === 'shared')
		        this.loadWallets()
        }

    }
</script>

<style scoped>

</style>
